"""
    @author: Sury Prakash Soni (suryasoni@gmail.com)
"""
import simplejson, traceback, sys
class CursorWrapper:
    def __init__(self, txnObj, cursList, joinedCursor):
        self.txnObj = txnObj
        self.cursList = cursList
        self.joinedCursor = joinedCursor
    
    def pop(self):
        return self.next(deleteItem=True)
    
    def get(self):
        return self.next(deleteItem=False)
    
    def next(self, deleteItem):
        key=None
        item=None
        if len(self.cursList)>0:
            try:
                if len(self.cursList)==1:
                    data = self.cursList[0].next()
                else:
                    data = self.joinedCursor.get(0)
                if data is not None:
                    (key, item) = data
                else:
                    raise TypeError
            except TypeError, e:
                raise
        else:
            (key, item) = self.joinedCursor.next()
        return key, simplejson.loads(item)


    def traverse(self, limit=-1):
        while True:
            try:
                print self.get()
                if limit>0:
                    limit -= 1
                if limit==0:
                    break
            except:
                break
        if limit==0:
            print "...More records available, but limited requested!"
        self.close()

    def close(self):
        self.joinedCursor.close()
        for cur in self.cursList:
            cur.close()
        self.txnObj.commit()
