"""
    @author: Sury Prakash Soni (suryasoni@gmail.com)
"""
from bdb.dbtable import *
import random, simplejson, shutil, sys

try:
    shutil.rmtree("dbs", True)
except:
    pass

def random_string(length=12, chars=string.letters + string.digits):
    return ''.join([random.choice(chars) for i in range(length)])


print "DB Environment Cleanup"
"""
    Indexing setup
"""
indexSetup              = {}
indexSetup[u'name']     = u"string"
indexSetup[u'age']      = u"int"
indexSetup[u'marks']    = u"int"
indexSetup[u'hobby']    = u"string"

"""
    Database creation
"""
db      = DBTable("test1", indexSetup)

print "DB Initialised"
"""
    Data population
"""
for i in range(500):
    d           = {}
    d[u'name']  = random_string()
    d[u'age']   = random.randint(12, 16)
    d[u'marks'] = random.randint(50, 60)
    d[u'hobby'] = random.choice(["cricket", "chess", "singing", "somersaulting", "dancing", "charity", "tasting wine"])
    db.append(d)

print "DB Loaded"

"""
    Query DB Table
"""
try:
    query           = {}
    query[u"age"]   = (u"like", u"14")
    iterator        = db.search(query)
    print "\nQuery:", query
    iterator.traverse(10)

    query[u"marks"] = (u"like", u"55")
    iterator        = db.search(query)
    print "\n\nQuery:", query
    iterator.traverse()

    query[u"hobby"] = (u"like", u"c")
    iterator        = db.search(query)
    print "\n\nQuery:", query
    iterator.traverse()
    
    db.close()
finally:
    """
        Cleanup
    """
print "\n\nAll Done"